<%@ page language="java" contentType="text/html;charset=utf-8" %>
<%@ taglib uri="/WEB-INF/struts-bean.tld" prefix="bean" %>
<%@ taglib uri="/WEB-INF/struts-html.tld" prefix="html" %>
<%@ taglib uri="/WEB-INF/struts-logic.tld" prefix="logic" %>
<%@ taglib uri="/WEB-INF/sj.tld" prefix="sj" %>

<html:html locale="true">
<%@ include file="../common/begin.jsp" %>

<body class="content">
<html:form action="/ApplyJonasServers">
<html:hidden property="action"/>
<sj:titleContent usingWhere="true" tomThumb="true"/>
<sj:tabs usingWhere="true" heightTab="20">
  <logic:equal name="domainForm" property="cluster" value="false">
    <sj:tab forward="ActionEditDomain" selected="true"><bean:message key="tab.domain"/></sj:tab>
  </logic:equal>
  <logic:equal name="domainForm" property="cluster" value="true">
    <sj:tab forward="ActionEditDomain"><bean:message key="tab.domain"/></sj:tab>
    <sj:tab forward="ActionEditDomain" selected="true"><bean:write name="clusterName"/></sj:tab>
  </logic:equal>
  <sj:panel>

    <sj:jonasgrid>
      <sj:jgRowTitle>
        <sj:jgColTitle>
          <bean:write name="domainForm" property="type"/>
          <bean:message key="label.domain.properties"/>
        </sj:jgColTitle>
      </sj:jgRowTitle>
    </sj:jonasgrid>
    <sj:jonasgrid>
      <sj:gridrow>
        <sj:jgName><bean:message key="label.domain.name"/></sj:jgName>
        <sj:jgValue><bean:write name="domainForm" property="name"/></sj:jgValue>
      </sj:gridrow>
	  <logic:present name="domainForm" property="description">
        <sj:jgName><bean:message key="label.domain.description"/></sj:jgName>
        <sj:jgValue><bean:write name="domainForm" property="description"/></sj:jgValue>
      </logic:present>
      <logic:equal name="domainForm" property="cluster" value="true">
        <sj:gridrow>
          <sj:jgName><bean:message key="label.domain.domainName"/></sj:jgName>
          <sj:jgValue><bean:write name="domainForm" property="domainName"/></sj:jgValue>
        </sj:gridrow>
        <sj:gridrow>
          <sj:jgName><bean:message key="label.domain.parentName"/></sj:jgName>
          <sj:jgValue>
              <html:link forward="ActionEditDomain" styleClass="panel"
                paramId="select" paramName="domainForm" paramProperty="parentON">
                <bean:write name="domainForm" property="parentName"/>
              </html:link>
          </sj:jgValue>
        </sj:gridrow>
      </logic:equal>
      <logic:equal name="domainForm" property="master" value="true">
        <sj:gridrow>
          <sj:jgName><bean:message key="label.domain.master"/></sj:jgName>
          <sj:jgValue>
            <html:link forward="ActionEditJonasServer" styleClass="panel"
              paramId="select" paramName="domainForm" paramProperty="masterON">
                <bean:write name="domainForm" property="masterName"/>
            </html:link>
          </sj:jgValue>
        </sj:gridrow>
      </logic:equal>
      <logic:equal name="domainForm" property="master" value="false">
        <sj:gridrow>
          <sj:jgName><bean:message key="label.domain.currentServer"/></sj:jgName>
          <sj:jgValue>
            <bean:write name="domainForm" property="masterName"/>
          </sj:jgValue>
        </sj:gridrow>
      </logic:equal>
    </sj:jonasgrid>

   <logic:equal name="domainForm" property="master" value="true">

    <sj:panelSeparator/>

    <sj:jonasgrid>
      <sj:jgRowTitle>
        <sj:jgColTitle>
          <bean:message key="label.domain.servers"/>
        </sj:jgColTitle>
      </sj:jgRowTitle>
    </sj:jonasgrid>

    <bean:size id="clustListSize" name="listClusters"/>
    <bean:size id="listSize" name="listServers"/>

    <!-- servers list -->
    <sj:jonasgrid>
      <sj:jgRowTitle level="2">
        <sj:jgColTitle><bean:message key="title.domain.action"/></sj:jgColTitle>
      </sj:jgRowTitle>
    </sj:jonasgrid>
    <sj:jonasgrid>
      <sj:gridrow changeStyle="true">
        <sj:gridcol>
          <sj:grid cellPadding="10">
            <sj:gridrow>
              <sj:gridcol>
                <sj:jonasbutton forward="ActionCreateJonasServer">
                  <bean:message key="action.button.domain.add.server"/>
                </sj:jonasbutton>
              </sj:gridcol>
              <logic:notEqual name="domainForm" property="nbCreatedServers" value="0">
                <sj:gridcol>
                  <sj:jonasbutton href="javascript:submitHidden('itemsServersForm','action','remove')">
                    <bean:message key="action.button.domain.remove.server"/>
                  </sj:jonasbutton>
                </sj:gridcol>
                <logic:equal name="domainForm" property="cluster" value="true">
                  <!-- always propose the Move in a Cluster -->
                  <sj:gridcol>
                    <sj:jonasbutton href="javascript:submitHidden('itemsServersForm','action','move')">
                      <bean:message key="action.button.domain.move.server"/>
                    </sj:jonasbutton>
                  </sj:gridcol>
                </logic:equal>
                <logic:equal name="domainForm" property="cluster" value="false">
                  <!-- in the domain, propose the Move if there are clusters -->
                  <logic:notEqual name="clustListSize" value="0">
                    <sj:gridcol>
                      <sj:jonasbutton href="javascript:submitHidden('itemsServersForm','action','move')">
                        <bean:message key="action.button.domain.move.server"/>
                      </sj:jonasbutton>
                    </sj:gridcol>
                  </logic:notEqual>
                </logic:equal>
              </logic:notEqual>
            </sj:gridrow>
          </sj:grid>
        </sj:gridcol>
      </sj:gridrow>
    </sj:jonasgrid>

    <sj:panelSeparator/>

    <sj:jonasgrid>
      <logic:equal name="listSize" value="0">
        <sj:gridrow>
          <logic:equal name="domainForm" property="cluster" value="false">
            <sj:gridcol><bean:message key="message.domain.servers.none"/></sj:gridcol>
          </logic:equal>
           <logic:equal name="domainForm" property="cluster" value="true">
            <sj:gridcol><bean:message key="message.cluster.servers.none"/></sj:gridcol>
           </logic:equal>
        </sj:gridrow>
      </logic:equal>
      <logic:notEqual name="listSize" value="0">
        <logic:iterate id="item" name="listServers">
          <sj:gridrow>
		    <sj:gridcol width="5%">
              <logic:equal name="item" property="state" value="created">
              <html:multibox property="selectedItems">
                <bean:write name="item" property="objectName"/>
              </html:multibox>
              </logic:equal>
              <logic:equal name="item" property="state" value="stopped">
              <html:multibox property="selectedItems">
                <bean:write name="item" property="objectName"/>
              </html:multibox>
              </logic:equal>
            </sj:gridcol>
            <sj:gridcol width="20%">
              <logic:equal name="item" property="state" value="started">
              <html:link forward="ActionEditJonasServer" styleClass="panel"
                paramId="select" paramName="item" paramProperty="objectName">
                <bean:write name="item" property="name"/>
              </html:link>
              </logic:equal>
              <logic:notEqual name="item" property="state" value="started">
                <bean:write name="item" property="name"/>
              </logic:notEqual>
            </sj:gridcol>
            <sj:gridcol>
              <bean:write name="item" property="state"/>
            </sj:gridcol>
          </sj:gridrow>
        </logic:iterate>
      </logic:notEqual>
    </sj:jonasgrid>

    <!-- clusters list -->
    <sj:panelSeparator/>

      <sj:jonasgrid>
        <sj:jgRowTitle>
          <sj:jgColTitle><bean:message key="label.domain.clusters"/></sj:jgColTitle>
        </sj:jgRowTitle>
    </sj:jonasgrid>

    <sj:jonasgrid>
      <sj:jgRowTitle level="2">
        <sj:jgColTitle><bean:message key="title.domain.action"/></sj:jgColTitle>
      </sj:jgRowTitle>
    </sj:jonasgrid>

    <sj:jonasgrid>
      <sj:gridrow changeStyle="true">
        <sj:gridcol>
          <sj:grid cellPadding="10">
            <sj:gridrow>
              <sj:gridcol>
                <sj:jonasbutton forward="ActionCreateCluster">
                  <bean:message key="action.button.domain.create.cluster"/>
                </sj:jonasbutton>
              </sj:gridcol>
            </sj:gridrow>
          </sj:grid>
        </sj:gridcol>
      </sj:gridrow>
    </sj:jonasgrid>

    <sj:panelSeparator/>

    <sj:jonasgrid>
      <logic:equal name="clustListSize" value="0">
        <sj:gridrow>
          <logic:equal name="domainForm" property="cluster" value="false">
            <sj:gridcol><bean:message key="message.domain.clusters.none"/></sj:gridcol>
          </logic:equal>
          <logic:equal name="domainForm" property="cluster" value="true">
            <sj:gridcol><bean:message key="message.cluster.clusters.none"/></sj:gridcol>
          </logic:equal>
        </sj:gridrow>
      </logic:equal>
      <logic:notEqual name="clustListSize" value="0">
        <logic:iterate id="itemClust" name="listClusters">
          <sj:gridrow>
		    <sj:gridcol width="5%"></sj:gridcol>
            <sj:gridcol width="20%">
              <html:link forward="ActionEditDomain" styleClass="panel"
                paramId="select" paramName="itemClust" paramProperty="objectName">
                <bean:write name="itemClust" property="name"/>
              </html:link>
            </sj:gridcol>
            <sj:gridcol>
            </sj:gridcol>
          </sj:gridrow>
        </logic:iterate>
      </logic:notEqual>
    </sj:jonasgrid>

   </logic:equal>

  </sj:panel>
</sj:tabs>

</html:form>
<%@ include file="../common/end.jsp" %>
</body>
</html:html>